include <dkart.dh>
include <windows.dh>
include <LookUp2DInc.dh>

local replace(s,s1,s2)
{
  while( StrFind(s,s1) )
    s=StrReplace(s,s1,s2);
}

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  chGetProperty(ch,CH_NAME,path);
  chGetProperty(ch,GEO_RELATE,rel);
  chGetProperty(ch,GEO_SCALE,scale);
  rel=scale/(rel*1000);
  path=StrLeft(path,StrRFind(path,"\\"));
  fes=ArCreate(0);
  if( GetResource("Object",fe) )
  {
    if( chGetMetricType(ch,fe) == M_AREA )
      ArAdd(fes,fe);
  }
  else
  {
    for( fe=0; fe=chNextFeature(ch,fe); )
      if( IsFeatureQueried(fe) && chGetMetricType(ch,fe) == M_AREA )
        ArAdd(fes,fe);
  }
  if( !ArSize(fes) )
  {
    ArFree(fes);
    return 0;
  }
  pars=ArCreate(0);
  ArAdd(pars," :");
  if( !ParamsDlg(" : "+ArSize(fes),pars) )
  {
    ArFree(pars);
    ArFree(fes);
    return;
  }
  name=ArGet(pars,1);
  ArFree(pars);
  name=StrLTrim(name);
  name=StrRTrim(name);
  if( name == "" )
  {
    puts("*** empty name not allowed");
    ArFree(fes);
    return;
  }
  name_eng=StrLwr(name);
  replace(name_eng,"  ","_");
  replace(name_eng," ","_");
  replace(name_eng,"","a");
  replace(name_eng,"","b");
  replace(name_eng,"","v");
  replace(name_eng,"","g");
  replace(name_eng,"","d");
  replace(name_eng,"","e");
  replace(name_eng,"","yo");
  replace(name_eng,"","zh");
  replace(name_eng,"","z");
  replace(name_eng,"","i");
  replace(name_eng,"","j");
  replace(name_eng,"","k");
  replace(name_eng,"","l");
  replace(name_eng,"","m");
  replace(name_eng,"","n");
  replace(name_eng,"","o");
  replace(name_eng,"","p");
  replace(name_eng,"","r");
  replace(name_eng,"","s");
  replace(name_eng,"","t");
  replace(name_eng,"","u");
  replace(name_eng,"","f");
  replace(name_eng,"","h");
  replace(name_eng,"","ts");
  replace(name_eng,"","ch");
  replace(name_eng,"","sh");
  replace(name_eng,"","sh");
  replace(name_eng,"","'");
  replace(name_eng,"","y");
  replace(name_eng,"","");
  replace(name_eng,"","e");
  replace(name_eng,"","yu");
  replace(name_eng,"","ya");
  x1=y1=0x7fffffff;
  x2=y2=-0x7fffffff;
  for( i=ArSize(fes); i; i-=1 )
  {
    fe=ArGet(fes,i);
    chFeatureBorder(ch,fe,fx1,fy1,fx2,fy2);
    if( x1 > fx1 )
      x1=fx1;
    if( y1 > fy1 )
      y1=fy1;
    if( x2 < fx2 )
      x2=fx2;
    if( y2 < fy2 )
      y2=fy2;
  }
  x0=(x1+x2)/2;
  y0=(y1+y2)/2;
  if( !(fp=fopen(path+name_eng+".dxf","w")) )
  {
    ArFree(fes);
    MessageBox("Cannot create file "+path+name_eng+".dxf",MB_ICONSTOP|MB_OK);
    return;
  }
  fputs("0\nSECTION\n2\nENTITIES\n",fp);
  for( i=ArSize(fes); i; i-=1 )
  {
    fe=ArGet(fes,i);
    cntnum=chGetFeatureArea(ch,fe,0,0,eg,flag);
//puts(""+cntnum);
    for( k=1; k<=cntnum; k+=1 )
    {
      xy=ArCreate(0);
      num=chGetFeatureArea(ch,fe,k,0,eg,flag);
//puts(""+k+" "+num);
      for( r=1; r<=num; r+=1 )
      {
        chGetFeatureArea(ch,fe,k,r,eg,flag);
        sz=chGetEdgeXY(ch,eg,0,x,y);
        if( flag & M_REVERSE )
        {
          for( j=sz-1; j>=0; j-=1 )
          {
            chGetEdgeXY(ch,eg,j,x,y);
            ArAdd(xy,x);
            ArAdd(xy,y);
          }
        }
        else
        {
          for( j=0; j<sz; j+=1 )
          {
            chGetEdgeXY(ch,eg,j,x,y);
            ArAdd(xy,x);
            ArAdd(xy,y);
          }
        }
      }
      num=ArSize(xy)-2;
//puts("*"+num);
      for( j=1; j<=num; j+=2 )
      {
        ix1=ArGet(xy,j);
        iy1=ArGet(xy,j+1);
        ix2=ArGet(xy,j+2);
        iy2=ArGet(xy,j+3);
//puts(""+j+" "+int(ix1)+" "+int(iy1)+" "+int(ix2)+" "+int(iy2));
        fputs("0\nLINE\n8\n0\n10\n"+printf("%.1f",(ix1-x0)*rel)+
                           "\n20\n"+printf("%.1f",(y0-iy1)*rel)+
                           "\n11\n"+printf("%.1f",(ix2-x0)*rel)+
                           "\n21\n"+printf("%.1f",(y0-iy2)*rel)+"\n",fp);
      }
      ArFree(xy);
    }
  }
  fputs("0\nENDSEC\n0\nEOF\n",fp);
  fclose(fp);
  chMap2Geo(ch,x1,y1,no,we);
  chMap2Geo(ch,x2,y2,so,ea);
  if( !(fp=fopen(path+name_eng+".xml","w")) )
  {
    ArFree(fes);
    MessageBox("Cannot create file "+path+name_eng+".xml",MB_ICONSTOP|MB_OK);
    return;
  }
  fputs("<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n",fp);
  fputs("<region name=\""+name+"\" ",fp);
  fputs("north=\""+printf("%.6f",no)+"\" west=\""+printf("%.6f",we)+"\" south=\""+printf("%.6f",so)+"\" east=\""+printf("%.6f",ea)+"\" angle=\"0\" height=\"0\"/>\n",fp);
  fclose(fp);
  for( i=ArSize(fes); i; i-=1 )
  {
    fe=ArGet(fes,i);
    chSetAttrText(ch,fe,INFORM,name_eng);
  }
  ArFree(fes);
}
